#include <stdio.h>

// Use this macro to check CUDA command return status
#define check(err, cmd) \
        do { if (err) { fprintf(stderr, "error: %s (code = %d/[%s])\n", cmd, err, cudaGetErrorString((cudaError_t) err)); exit(1); } } while (0)

// Device code
__global__ void VecAdd(float* A, float* B, float* C, int N) {
        int i = /* TODO: compute index */;
        if (i < N)
                C[i] = A[i] + B[i];
}

// Host code
int main() {
        int err;        // store status of CUDA commands
        int N = 512;    // vector size (nb of elements)
        size_t size = N * sizeof(float);        // vector size (nb of bytes)
        int i;          // loop counter

        // Host vectors
        float* h_A;	// input vector A
        float* h_B;	// input vector B
        float* h_C;	// result vector C
        float* h_D;	// reference result vector D

        // Device vectors
        float* d_A;
        float* d_B;
        float* d_C;

        // Allocate input/result vectors in host memory
        h_A = (float *)malloc(size);
        h_B = (float *)malloc(size);
        h_C = (float *)malloc(size);
        h_D = (float *)malloc(size);

        // Initialize input vectors
        for (i = 0; i < N; i++) {
                h_A[i] = i*1.0f;
                h_B[i] = i*2.0f;
                h_D[i] = h_A[i]+h_B[i];
        }

        // Allocate vectors in device memory
        // TODO: allocate d_A vector on device
        // TODO: allocate d_B vector on device
        // TODO: allocate d_C vector on device

        // Copy vectors from host memory to device memory
	// TODO: send vector h_A contents to d_A
	// TODO: send vector h_B contents to d_B

        // Invoke kernel
        // TODO: invoke the VecAdd kernel

        // Copy result vector from device memory to host memory
	// TODO: retrieve resulting vector d_C contents to h_C

	// Check result
	// TODO: check that the kernel result is ok

        // Free device memory
        // TODO: free d_A vector on device
        // TODO: free d_B vector on device
        // TODO: free d_C vector on device

        // Free host memory
        free(h_A);
        free(h_B);
        free(h_C);
        free(h_D);

        return 0;
}
